{------------------------------------------------------------------------------}
{  Unit DBIniMemo                                                             }
{  Auteur : (c) 1997/98/99 Jean-Michel BOUCTON                                 }
{  email : jmbo@softhome.net                                                   }
{  Web :http://www.chez.com/jmbo                                               }
{                                                                              }
{  Cration : 12 octobre 1997                                                  }
{  Version : voir en fin d'en-tte                                             }
{                                                                              }
{  COPYRIGHT                                                                   }
{                                                                              }
{  Ce composant est un gratuiciel et donc libre de droits. Il est fourni       }
{  TEL QUEL, sans aucune garantie expresse ou tacite, pour quelque raison      }
{  que ce soit, y compris d'ventuels dommages causs par l'utilisation de ce  }
{  composant, les dommages pour pertes de profits, cessation d'activites       }
{  commerciales ou autre.                                                      }
{  Vous pouvez utiliser ce composant comme bon vous semble, except pour une   }
{  utilisation commerciale, c'est  dire ne pas utiliser tout ou  partie de ce }
{  composant dans un projet commercial (un comble!).                           }
{  Vous ne pouvez pas prtendre avoir crit ce composant et vous n'tes pas    }
{  autoris  supprimer l'en-tte du fichier source (question d'thique).      }
{  Si vous n'tes pas en accord avec ce qui prcde, ne l'utilisez pas.        }
{                                                                              }
{  Si vous modifiez le fichier source ou apportez des corrections ou des       }
{  ajouts, ajoutez simplement des commentaires, une description et votre nom  }
{  la fin de l'en-tte. Dans ce cas merci de m'en envoyer une copie.           }
{                                                                              }
{  Vous pouvez m'envoyer un courrier lectronique avec une liste de bugs, une  }
{  demande de modification ou de dveloppement particulier sur la mme base.   }
{  D'une manire gnrale, tous commentaires ou suggestion seront apprcis.   }
{  S'il vous plat, dites moi ce que vous faites avec ce composant.            }
{  D'autre part, j'apprcierais beaucoup une carte postale de l'endroit o     }
{  vous tes (envoyez moi un email avant, pour l'adresse postale).             }
{                                                                              }
{  DESCRIPTION                                                                 }
{                                                                              }
{  Ce composant possde les fonctions de base de TIniFile, mais sauvegarde     }
{  les infos dans un champ Mmo d'une base de donne. Permet la sauvegarde de  }
{  configurations multiple pour chaque enregistrement (ex.profils utilisateurs)}
{  Permet aussi d'enregistrer les proprits de certains composants (liste    }
{  complter), voir les fonctions StoreObject et RestoreObject.                }
{                                                                              }
{  UTILISATION                                                                 }
{                                                                              }
{  Pour l'utilisation voir le source du programme de test IniMemoFieldTest     }
{                                                                              }
{  Fonctions identiques  TIniFile :                                           }
{    ReadString, ReadInteger, ReadBool, WriteString, WriteInteger, WriteBool,  }
{    ReadSection, ReadSections, ReadSectionValues, EraseSection.               }
{  Fonctions pour sauvegarder et restaurer quelques proprits de composant :  }
{    DeleteKey, GetObjectSection, RegisterObject, UnRegisterObject,            }
{    RestoreObject, RestoreObjects, StoreObject, StoreObjects.                 }
{  Fonctions pour les "Cls" :                                                 }
{    IsReadOnlyKey, TypeOfItems.                                               }
{  Nouvelles proprits :                                                      }
{    DataField, DataSource, ReadOnly, CaseSensitive, ExceptionOnError,         }
{    IgnoreCommentLines, AutoStore, ObjectSection.                             }
{==============================================================================}
{  Version : 1.0.0 du 25 novembre 1997                                         }
{     Auteur : Jean-Michel BOUCTON                                             }
{     Cration et version finale.                                              }
{==============================================================================}
{  Version : 1.1.0 26 fvrier 1999                                             }
{     Auteur : Jean-Michel BOUCTON                                             }
{     Changements mineurs pour la recompilation avec Delphi 2.                 }
{==============================================================================}
{  Version :                                                                   }
{     Auteur :                                                                 }
{     .                                                                        }
{------------------------------------------------------------------------------}
unit DbIniMemo;

interface

uses Windows, SysUtils, Messages, Classes,
     Db, DBCtrls, XStrTool, Dialogs, Forms, StdCtrls, FileCtrl,
     TabNotBK, Menus, DBTables;

type

  EDBIniMemoError = class(Exception);

  TDBIniMemoType = (imtDBError, imtValidSection, imtInvalidSection, imtROKey,
                    imtRWKey, imtInvalidKey, imtCommentLine);
{ TDBIniMemo }

  TDBIniMemo = class(TComponent)
  private
    FDataLink: TFieldDataLink;
    FDataChange: boolean;
    FWriting: boolean;
    FCaseSensitive: boolean;
    FExceptOnError: boolean;
    FIgnoreCommentLines: boolean;
    FAutoStore: boolean;
    FRegObjects: TStringList;
    FObjectSection: String;
    procedure DataChange(Sender: TObject);
    procedure EditingChange(Sender: TObject);
    procedure UpdateData(Sender: TObject);
    function GetDataField: string;
    function GetDataSource: TDataSource;
    function GetField: TField;
    function GetReadOnly: Boolean;
    function GetIgnoreCommentLines: boolean;
    procedure SetDataField(const Value: string);
    procedure SetDataSource(Value: TDataSource);
    procedure SetReadOnly(Value: Boolean);
    procedure SetIgnoreCommentLines(Value: boolean);
    function GetMemoProfileString(lpAppName,        // section name
                                  lpKeyName,        // key name
                                  lpDefault: PChar; // default string
                                  lpReturnedString: PChar; // dest. buffer
                                  nSize: integer;   // size of dest. buffer
                                  oMemo: TMemoField // Memo field
                                 ): integer;
    function WriteMemoProfileString(lpAppName,       // section name
                                    lpKeyName,       // key name
                                    lpValue: PChar;  // string value
                                    oMemo: TMemoField // Memo field
                                   ): boolean;
    function SearchSection(lpAppName: PChar; oMemo: TMemoField): PChar;
    function WriteMemo(S: string): boolean;
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Field: TField read GetField;
    function ReadString(const Section, Ident, Default: string): string;
    function WriteString(const Section, Ident, Value: string): boolean;
    function ReadInteger(const Section, Ident: string; Default: Longint): Longint;
    procedure WriteInteger(const Section, Ident: string; Value: Longint);
    function ReadBool(const Section, Ident: string; Default: Boolean): Boolean;
    procedure WriteBool(const Section, Ident: string; Value: Boolean);
    procedure ReadSections(Strings: TStrings);
    procedure ReadSection(const Section: string; Strings: TStrings);
    procedure ReadSectionValues(const Section: string; Strings: TStrings);
    procedure EraseSection(const Section: string);
    procedure DeleteKey(const Section, Ident: String);
    function GetObjectSection(obj: TObject): string;
    procedure RegisterObject(obj: TObject; ObjectSection: string);
    procedure UnRegisterObject(obj: TObject);
    procedure RestoreObject(obj: TObject; ObjectSection: string);
    procedure RestoreObjects;
    procedure StoreObject(obj: TObject; ObjectSection: string);
    procedure StoreObjects;
    function IsReadOnlyKey(const Section, Ident: string; var ROKey: boolean): integer;
    procedure TypeOfItems(const Section, Ident: string; var TypeItem: TDBIniMemoType);
  published
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
    property CaseSensitive: Boolean read FCaseSensitive write FCaseSensitive default False;
    property ExceptionOnError: Boolean read FExceptOnError write FExceptOnError default False;
    property IgnoreCommentLines: Boolean read GetIgnoreCommentLines write SetIgnoreCommentLines default True;
    property AutoStore: boolean read FAutoStore write FAutoStore;
    property ObjectSection: string read FObjectSection write FObjectSection;
  end;

implementation

function GetLine(BufPtr, Buffer: PChar): PChar;
var
  P: PChar;
begin
  P := StrPos(BufPtr, #13#10);
  if P = nil then
  begin
    StrLCopy(Buffer, BufPtr, StrLen(BufPtr));
    Result := BufPtr + StrLen(BufPtr);
    if Result^ = '' then
      Result := nil;
  end else
  begin
    StrLCopy(Buffer, BufPtr, P - BufPtr);
    Result := P + 2;
  end;
end;

procedure SplitKeyValue(S: string; var SearchKey, Value: string);
var
  slen: integer;
begin
  SearchKey := Trim(Copy(S, 1, Pos('=', S)-1));
  Value := Trim(Copy(S, Pos('=', S)+1, Length(S)));
  slen := Length(Value);
  if (Pos('"', Value) > 0) or (Pos('''', Value) > 0) then
  begin
    if (Value[1] = '"') or (Value[1] = '''') then
    begin
      Value := Copy(Value, 2, slen - 1);
      Dec(slen);
    end;
    if (Value[slen] = '"') or (Value[slen] = '''') then
      Value := Copy(Value, 1, slen - 1);
    Value := Trim(Value);
  end;
end;

{ TDBIniMemo }

constructor TDBIniMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := nil;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnEditingChange := EditingChange;
  FDataLink.OnUpdateData := UpdateData;
  FDataChange := false;
  FWriting := true;
  FCaseSensitive := false;
  FExceptOnError := false;
  FIgnoreCommentLines := true;
  FRegObjects:= TStringList.Create;
  FObjectSection:= 'ObjectsOptions';  // Objects section name, by default
end;

destructor TDBIniMemo.Destroy;
begin
  FDataLink.Free;
  FDataLink := nil;
  if FAutoStore then
    StoreObjects;
  FRegObjects.Free;
  inherited Destroy;
end;

function TDBIniMemo.GetMemoProfileString(lpAppName,
                                         lpKeyName,
                                         lpDefault: PChar;
                                         lpReturnedString: PChar;
                                         nSize: integer;
                                         oMemo: TMemoField
                                        ): integer;
const
  pTopSection: PChar = '[';
  pEndSection: PChar = ']';
var
  PosSection, PosNextSection: PChar;
  PosKey, PBuf, PEnd: PChar;
  pSearchSection: array[0..64] of char;
  pTemp: array[0..127] of char;
  SearchKey, Value: string;
  numbyte, bytecopied: integer;
begin
  Result := 0;
  FillChar(pSearchSection, sizeof(pSearchSection), #0);
  FillChar(pTemp, sizeof(pTemp), #0);
  FillChar(lpReturnedString^, sizeof(lpReturnedString), #0);
  if oMemo <> nil then
  begin
    if (lpAppName <> nil) and (lpKeyName <> nil) then  // key and section
    begin
      // Return default value if section or key is untraceable
      StrCopy(lpReturnedString, lpDefault);
      Result := StrLen(lpReturnedString);
      PosSection := SearchSection(lpAppName, oMemo);
      // the section was found and is valid
      if PosSection <> nil then
      begin
        // Search the next section
        PosNextSection := StrPos(PosSection + 1, pTopSection);
        // Search the key
        if FCaseSensitive then
          PosKey := StrPos(PosSection, lpKeyName)
        else
          PosKey := StrIPos(PosSection, lpKeyName);
        if (PosKey <> nil) and ((PosKey < PosNextSection) or (PosNextSection = nil)) then
        begin
          if FIgnoreCommentLines then
          begin
            while (PosKey^ <> #10) and (PosKey >= PosSection) do
              dec(PosKey);
            inc(PosKey);
          end;
          // Read line which contains the key
          GetLine(PosKey, ptemp);
          // Extract the key and its value
          SplitKeyValue(pTemp, SearchKey, Value);
          if SearchKey = '' then     // Line invalidates (not contain '=')
            exit;
          if (SearchKey[1] = #59) then
            if FIgnoreCommentLines then
              exit
            else
              SearchKey := Copy(SearchKey, 2, Length(SearchKey) - 1);
            // Indicate a read only property
            if SearchKey[1] = '-' then
              SearchKey := Copy(SearchKey, 2, Length(SearchKey) - 1);
          // Avoid the partial keys
          if StrIComp(StrTrim(lpKeyName), PChar(SearchKey)) <> 0 then
            exit;
          StrCopy(lpReturnedString, PChar(Value));
          Result := StrLen(lpReturnedString);
        end;  // Key not found
      end;  // Section not found
    end else if (lpAppName = nil) and (lpKeyName = nil)then    // ReadSections
    begin
      // PBuf at the beginning of out buffer
      PBuf := lpReturnedString;
      bytecopied := 0;
      // Beginning of memo field
      PosSection := PChar(oMemo.Value);
      repeat
        // Search a beginning section
        PosSection := StrPos(PosSection, pTopSection);
        if PosSection = nil then
          continue;
        // Beginning of section name
        Inc(PosSection);
        // Get contents of line
        GetLine(PosSection, pTemp);
        // Search end of section in the buffer line
        PEnd := StrPos(pTemp, pEndSection);
        if pEnd = nil then
        begin
          // Error on section, search a next section
          PosSection := StrPos(PosSection, pTopSection);
          FillChar(pTemp, sizeof(pTemp), #0);
          continue;
        end;
        // Copy the section
        StrLCopy(pTemp, pTemp, pEnd - pTemp);
        StrTrim(pTemp);
        numbyte := StrLen(pTemp);
        if (bytecopied + numbyte + 2) > nSize then
        begin
          numbyte := nSize - bytecopied - 2;
          if numbyte = 0 then
            break;
          StrLCopy(pTemp, pTemp, numbyte);
        end;
        // Copy the key in out buffer
        move(pTemp, PBuf^, numbyte + 1);
        bytecopied := bytecopied + numbyte + 1;
        // Position the pointer after the end zero
        PBuf := PBuf + numbyte + 1;
        FillChar(pTemp, sizeof(pTemp), #0);
        if bytecopied >= (nSize - 2) then
        begin
          bytecopied := nSize - 2;
          break;
        end;
      until (PosSection = nil);
      // Add second zero at end buffer
      move(pTemp, PBuf^, 1);
      Result := bytecopied;
    end else if (lpAppName <> nil) and (lpKeyName = nil) then  // ReadSection
    begin
      PosSection := SearchSection(lpAppName, oMemo);
      // the section was found and is valid
      if PosSection <> nil then
      begin
        bytecopied := 0;
        // Search next section
        PosNextSection := StrPos(PosSection + 1, pTopSection);
        PosKey := StrPos(PosSection, pEndSection) +1;
        PBuf := lpReturnedString;
        repeat
          // Read line which contains the key
          PosKey := GetLine(PosKey, pTemp);
          if pTemp = '' then
            continue;
          if StrPos(pTemp, '=') = nil then   // Ligne invalide
            continue;
          // Get the key
          StrLCopy(pTemp, pTemp, StrPos(pTemp, '=') - pTemp);
          StrTrim(pTemp);
          if (pTemp[0] = ';') then
            if FIgnoreCommentLines then
              continue
            else
              StrLCopy(pTemp, pTemp + 1, StrLen(pTemp) -1);
          if (pTemp[0] = ';') and FIgnoreCommentLines then
            continue;
            // Indicate a read only property
            if pTemp[0] = '-' then
              StrLCopy(pTemp, pTemp + 1, StrLen(pTemp) -1);
          numbyte := StrLen(pTemp);
          if (bytecopied + numbyte + 2) > nSize then
          begin
            numbyte := nSize - bytecopied - 2;
            if numbyte = 0 then
              break;
            // Truncate the last string
            StrLCopy(pTemp, pTemp, numbyte);
          end;
          // Copy the key in out buffer
          move(pTemp, PBuf^, numbyte + 1);
          bytecopied := bytecopied + numbyte + 1;
          // Position the pointer after the end zero
          PBuf := PBuf + numbyte + 1;
          FillChar(pTemp, sizeof(pTemp), #0);
          if bytecopied >= (nSize - 2) then
          begin
            bytecopied := nSize - 2;
            break;
          end;
        until (PosKey = nil) or ((PosKey >= PosNextSection) and (PosNextSection <> nil));
        // Add second zero at end buffer
        move(pTemp, PBuf^, 1);
        Result := bytecopied;
      end;  // Section not found
    end;
  end;
end;

function TDBIniMemo.SearchSection(lpAppName: PChar; oMemo: TMemoField): PChar;
const
  CharTopSection: PChar = '[';
  CharEndSection: PChar = ']';
var
  PosSection: PChar;
  PTop: PChar;
  pSearchSection: array[0..64] of char;
begin
  Result := nil;
  PTop := PChar(oMemo.Value);
  FillChar(pSearchSection, sizeof(pSearchSection), #0);
  if FCaseSensitive then
    PosSection := StrPos(PTop, lpAppName)
  else
    PosSection := StrIPos(PTop, lpAppName);
  // Section found
  if PosSection <> nil then
  begin
    while (PosSection^ <> #10) and (PosSection >= PTop) do
      dec(PosSection);
    inc(PosSection);
    // Get contents of line
    GetLine(PosSection, pSearchSection);
    // Check if it's a section surrounded by '[' and ']'
    if (StrPos(pSearchSection, CharTopSection) = nil) or
       (StrPos(pSearchSection, CharEndSection) = nil) then
      exit;
    // Real beginning of section '[' on the line
    PosSection :=  StrPos(PosSection, CharTopSection);
    // Get exact name of found section
    StrLCopy(pSearchSection, PosSection + 1, StrPos(PosSection, CharEndSection) - (PosSection+1));
    StrTrim(pSearchSection);
    // Avoid the partial section names
    if StrIComp(StrTrim(lpAppName), pSearchSection) <> 0 then
      exit;
    Result := PosSection;
  end;
end;

function TDBIniMemo.WriteMemoProfileString(lpAppName,
                                           lpKeyName,
                                           lpValue: PChar;
                                           oMemo: TMemoField
                                          ): boolean;
const
  pTopSection: PChar = '[';
  pEndSection: PChar = ']';
var
  PosSection, PosNextSection: PChar;
  PosKey, PEnd: PChar;
  //PBuf: PChar
  pSearchSection: array[0..64] of char;
  pTemp: array[0..127] of char;
  SearchKey, Value: string;
  BytesToDelete, FirstByte: integer;
  BufString, Newline: string;
begin
  Result := false;
  FillChar(pSearchSection, sizeof(pSearchSection), #0);
  FillChar(pTemp, sizeof(pTemp), #0);
  Newline := '';
  if oMemo <> nil then
  begin
    FDataChange := false;
    FWriting := false;
    if (lpAppName <> nil) and (lpKeyName <> nil) and (lpValue = nil) then
    begin   // Delete Key
      PosSection := SearchSection(lpAppName, oMemo);
      if PosSection <> nil then
      begin
        BufString := oMemo.Value;
        // Search next section
        PosNextSection := StrPos(PosSection + 1, pTopSection);
        // Search the key
        if FCaseSensitive then
          PosKey := StrPos(PosSection, lpKeyName)
        else
          PosKey := StrIPos(PosSection, lpKeyName);
        if (PosKey <> nil) and ((PosKey < PosNextSection) or (PosNextSection = nil)) then
        begin
          while (PosKey^ <> #10) and (PosKey >= PosSection) do
            dec(PosKey);
          inc(PosKey);
          // Read line which contains the key
          PEnd := GetLine(PosKey, ptemp);
          if PEnd <> nil then
            BytesToDelete := StrLen(pTemp) + 2
          else
            BytesToDelete := StrLen(pTemp);
          // Extract the key
          SearchKey := Trim(Copy(pTemp, 1, Pos('=', pTemp)-1));
          // The line is invalid and not contain '='
          if SearchKey = '' then
            SearchKey := Trim(Copy(pTemp, 1, Pos(' ', pTemp)-1));
          // Read only key
          if SearchKey[1] = '-' then
            if FExceptOnError then
              raise Exception.Create('TDBIniMemo.WriteMemoProfileString : Key is ReadOnly')
            else
              exit;
          // Avoid the partial key names
          if StrIComp(StrTrim(lpKeyName), PChar(SearchKey)) <> 0 then
            exit;
          FirstByte := (PosKey - PChar(BufString)) + 1;  // Base 0
          Delete(BufString, FirstByte, BytesToDelete);
          if not ReadOnly then
          begin
            FWriting := true;
            Result := WriteMemo(BufString)
          end else
            if FExceptOnError then
              raise Exception.Create('TDBIniMemo.WriteMemoProfileString : DataField is ReadOnly');
        end;
      end;  { if PosSection <> nil then }
    end else if (lpAppName <> nil) and (lpKeyName <> nil) then
    begin
      PosSection := SearchSection(lpAppName, oMemo);
      if PosSection <> nil then
      begin
        BufString := oMemo.Value;
        // Search next section
        PosNextSection := StrPos(PosSection + 1, pTopSection);
        // Search key
        if FCaseSensitive then
          PosKey := StrPos(PosSection, lpKeyName)
        else
          PosKey := StrIPos(PosSection, lpKeyName);
        if (PosKey <> nil) and ((PosKey < PosNextSection) or (PosNextSection = nil)) then
        begin
          if FIgnoreCommentLines then
          begin
            while (PosKey^ <> #10) and (PosKey >= PosSection) do
              dec(PosKey);
            inc(PosKey);
          end;
          // Read line which contains the key
          GetLine(PosKey, ptemp);
          BytesToDelete := StrLen(pTemp);
          // Extract the key and its value
          SplitKeyValue(pTemp, SearchKey, Value);
          // Indicate a read only key
          if SearchKey[1] = '-' then
            if FExceptOnError then
              raise Exception.Create('TDBIniMemo.WriteMemoProfileString : Key is ReadOnly')
            else
              exit;
          // Avoid the partial key names
          if StrIComp(StrTrim(lpKeyName), PChar(SearchKey)) <> 0 then
            exit;
          if FIgnoreCommentLines then
            if SearchKey[1] = #59 then
              exit;
          // if invalid Line (not contain '=') make it valid
          // if SearchKey = '' then
          Value := lpValue;
          FirstByte := (PosKey - PChar(BufString)) + 1;  // Base 0
          BufString := ReplaceLStr(BufString, FirstByte, BytesToDelete, SearchKey+'='+Value);
          if not ReadOnly then
          begin
            FWriting := true;
            Result := WriteMemo(BufString)
          end else
            if FExceptOnError then
              raise Exception.Create('TDBIniMemo.WriteMemoProfileString : DataField is ReadOnly');
        end else  // Key not found
        begin
          // Search end section
          PEnd := StrPos(PosSection, #13#10);
          if PEnd = nil then
            PEnd := StrPos(PosSection, pEndSection)
          else
            PEnd := PEnd + 2;
          PosKey := PEnd;
          repeat
            // Read current line
            PosKey := GetLine(PosKey, ptemp);
            if PosKey = nil then
              break;
          until (pTemp = '') or ((PosKey >= PosNextSection) and (PosNextSection <> nil));
          if (pTemp = '') and (PosKey <> nil) then
          begin
            PosKey := PosKey - 2;
            Newline := lpKeyName + '=' + lpValue + #13#10;
          end else if PosKey = nil then
          begin
            PosKey := PChar(BufString) + Length(BufString);
            Newline := #13#10 + lpKeyName + '=' + lpValue;
          end;
          FirstByte := (PosKey - PChar(BufString)) + 1;  // Base 0
          // Insert the new key and its value
          Insert(Newline, BufString, FirstByte);
          if not ReadOnly then
          begin
            FWriting := true;
            Result := WriteMemo(BufString)
          end else
            if FExceptOnError then
              raise Exception.Create('TDBIniMemo.WriteMemoProfileString : DataField is ReadOnly');
        end;
      end else   // Section not exist
      begin
        BufString := oMemo.Value;
        PosKey := (PChar(BufString) + Length(BufString));
        Dec(PosKey);
        if PosKey^ <> #10 then
          Newline := #13#10;
        if lpKeyName^ = '' then
          Newline := Newline + #13#10 + pTopSection + lpAppName + pEndSection
        else
          Newline := Newline + #13#10 + pTopSection + lpAppName + pEndSection + #13#10 + lpKeyName + '=' + lpValue;
        BufString := BufString + Newline;
        if not ReadOnly then
        begin
          FWriting := true;
          Result := WriteMemo(BufString)
        end else
          if FExceptOnError then
            raise Exception.Create('TDBIniMemo.WriteMemoProfileString : DataField is ReadOnly');
      end;
    end else if (lpAppName <> nil) and (lpKeyName = nil) then
    begin   // Delete Section
      PosSection := SearchSection(lpAppName, oMemo);
      if PosSection <> nil then
      begin
        BufString := oMemo.Value;
        // Search next section
        PosNextSection := StrPos(PosSection + 1, pTopSection);
        if PosNextSection <> nil then  // End string
          BytesToDelete := PosNextSection - PosSection
        else
          BytesToDelete := Length(BufString) +(PChar(BufString) - PosSection);
        FirstByte := (PosSection - PChar(BufString)) + 1;  // Base 0
        Delete(BufString, FirstByte, BytesToDelete);
        if not ReadOnly then
        begin
          FWriting := true;
          Result := WriteMemo(BufString)
        end else
          if FExceptOnError then
            raise Exception.Create('TDBIniMemo.WriteMemoProfileString : DataField is ReadOnly');
      end;
    end;
  end;
end;

function TDBIniMemo.WriteMemo(S: string): boolean;
begin
  Result := false;
  if not FDataChange then
  begin
    if FDataLink.Edit then
    begin
      TMemoField(FDataLink.Field).AsString := S;
      FDataLink.DataSet.Post;
      FWriting := false;
      Result := true;
    end;
  end else
    if FWriting then
      raise Exception.Create('TDBIniMemo.WriteMemo : No Writing, Dataset has changed');
end;

procedure TDBIniMemo.DataChange(Sender: TObject);
begin
  if FDataLink.Field <> nil then
    if (FDataLink.Field.DataType = ftMemo) or
       (FDataLink.Field.DataType = ftBlob) then //ftBlob,  if FDataLink.Field.IsBlob then
    begin
      if not FDataChange and FWriting then
        FDataChange := true;
    end;
end;

procedure TDBIniMemo.EditingChange(Sender: TObject);
begin
//  inherited ReadOnly := not (FDataLink.Editing and FMemoLoaded);
end;

procedure TDBIniMemo.UpdateData(Sender: TObject);
begin
//  ShowMessage('UpdateData');
//  FDataLink.Field.AsString := Text;
end;

function TDBIniMemo.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TDBIniMemo.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

function TDBIniMemo.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

procedure TDBIniMemo.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
end;

function TDBIniMemo.GetField: TField;
begin
  Result := FDataLink.Field;
end;

function TDBIniMemo.GetReadOnly: Boolean;
begin
  Result := FDataLink.ReadOnly;
end;

procedure TDBIniMemo.SetReadOnly(Value: Boolean);
begin
  FDataLink.ReadOnly := Value;
end;

function TDBIniMemo.GetIgnoreCommentLines: boolean;
begin
  Result := FIgnoreCommentLines;
end;

procedure TDBIniMemo.SetIgnoreCommentLines(Value: Boolean);
begin
  FIgnoreCommentLines := Value;
end;

function TDBIniMemo.ReadString(const Section, Ident, Default: string): string;
var
  Buffer: array[0..1023] of Char;
begin
  if Assigned(FDataLink.Field) and
    ((FDataLink.Field.DataType = ftMemo) or (FDataLink.Field.DataType = ftBlob)) then
    SetString(Result, Buffer, GetMemoProfileString(PChar(Section), PChar(Ident),
                                                   PChar(Default),
                                                   Buffer, SizeOf(Buffer),
                                                   TMemoField(FDataLink.Field))
             );
end;

function TDBIniMemo.WriteString(const Section, Ident, Value: string): boolean;
begin
  Result := WriteMemoProfileString(PChar(Section), PChar(Ident),
                                   PChar(Value),
                                   TMemoField(FDataLink.Field));
  if (not Result) and FExceptOnError then
    raise Exception.Create('TDBIniMemo.WriteString : Error in writing Memo');
end;

function TDBIniMemo.ReadInteger(const Section, Ident: string;
  Default: Longint): Longint;
var
  IntStr: string;
begin
  IntStr := ReadString(Section, Ident, '');
  if (Length(IntStr) > 2) and (IntStr[1] = '0') and
    ((IntStr[2] = 'X') or (IntStr[2] = 'x')) then
    IntStr := '$' + Copy(IntStr, 3, Maxint);
  Result := StrToIntDef(IntStr, Default);
end;

procedure TDBIniMemo.WriteInteger(const Section, Ident: string; Value: Longint);
begin
  WriteString(Section, Ident, IntToStr(Value));
end;

function TDBIniMemo.ReadBool(const Section, Ident: string;
  Default: Boolean): Boolean;
begin
  Result := ReadInteger(Section, Ident, Ord(Default)) <> 0;
end;

procedure TDBIniMemo.WriteBool(const Section, Ident: string; Value: Boolean);
const
  Values: array[Boolean] of string = ('0', '1');
begin
  WriteString(Section, Ident, Values[Value]);
end;

procedure TDBIniMemo.ReadSections(Strings: TStrings);
const
  BufSize = 8192;
var
  bytecopied: integer;
  Buffer, P: PChar;
begin
  GetMem(Buffer, BufSize);
  try
    Strings.BeginUpdate;
    try
      Strings.Clear;
      bytecopied := GetMemoProfileString(nil, nil, nil, Buffer, BufSize,
                       TMemoField(FDataLink.Field));
      if bytecopied = BufSize - 2 then
        if FExceptOnError then
          raise Exception.Create('TDBIniMemo.ReadSection : Buffer to small');
      if bytecopied <> 0 then
      begin
        P := Buffer;
        while P^ <> #0 do
        begin
          Strings.Add(P);
          Inc(P, StrLen(P) + 1);
        end;
      end;
    finally
      Strings.EndUpdate;
    end;
  finally
    FreeMem(Buffer, BufSize);
  end;
end;

procedure TDBIniMemo.ReadSection(const Section: string; Strings: TStrings);
const
  BufSize = 8192;
var
  bytecopied: integer;
  Buffer, P: PChar;
begin
  GetMem(Buffer, BufSize);
  try
    Strings.BeginUpdate;
    try
      Strings.Clear;
      bytecopied := GetMemoProfileString(PChar(Section), nil, nil, Buffer, BufSize,
                       TMemoField(FDataLink.Field));
      if bytecopied = BufSize - 2 then
        if FExceptOnError then
          raise Exception.Create('TDBIniMemo.ReadSection : Buffer to small');
      if bytecopied <> 0 then
      begin
        P := Buffer;
        while P^ <> #0 do
        begin
          Strings.Add(P);
          Inc(P, StrLen(P) + 1);
        end;
      end;
    finally
      Strings.EndUpdate;
    end;
  finally
    FreeMem(Buffer, BufSize);
  end;
end;

procedure TDBIniMemo.ReadSectionValues(const Section: string; Strings: TStrings);
var
  KeyList: TStringList;
  i: Integer;
begin
  KeyList := TStringList.Create;
  try
    ReadSection(Section, KeyList);
    Strings.BeginUpdate;
    Strings.Clear;
    try
      for i := 0 to KeyList.Count - 1 do
        Strings.Values[KeyList[i]] := ReadString(Section, KeyList[i], '');
    finally
      Strings.EndUpdate;
    end;
  finally
    KeyList.Free;
  end;
end;

procedure TDBIniMemo.EraseSection(const Section: string);
begin
  if (not WriteMemoProfileString(PChar(Section), nil, nil,
      TMemoField(FDataLink.Field))) and FWriting then
    raise Exception.Create('TDBIniMemo.EraseSection : Error in writing Memo');
end;

procedure TDBIniMemo.DeleteKey(const Section, Ident: String);
begin
  if (not WriteMemoProfileString(PChar(Section), PChar(Ident), nil,
      TMemoField(FDataLink.Field))) and FWriting then
    raise Exception.Create('TDBIniMemo.DeleteKey : Error in writing Memo');
end;

function TDBIniMemo.IsReadOnlyKey(const Section, Ident: string; var ROKey: boolean): integer;
const
  pTopSection: PChar = '[';
var
  PosSection, PosNextSection: PChar;
  PosKey: PChar;
  pSearchSection: array[0..64] of char;
  pTemp: array[0..127] of char;
  SearchKey, Value: string;
  oMemo: TMemoField;
begin
  Result := -1;
  ROKey := false;
  FillChar(pSearchSection, sizeof(pSearchSection), #0);
  FillChar(pTemp, sizeof(pTemp), #0);
  oMemo := TMemoField(FDataLink.Field);
  if oMemo <> nil then
  begin
    if (Section <> '') and (Ident <> '') then
    begin
      PosSection := SearchSection(PChar(Section), oMemo);
      // Section found and valid
      if PosSection <> nil then
      begin
        // Search next section
        PosNextSection := StrPos(PosSection + 1, pTopSection);
        // Search the key
        if FCaseSensitive then
          PosKey := StrPos(PosSection, PChar(Ident))
        else
          PosKey := StrIPos(PosSection, PChar(Ident));
        if (PosKey <> nil) and ((PosKey < PosNextSection) or (PosNextSection = nil)) then
        begin
          while (PosKey^ <> #10) and (PosKey >= PosSection) do
            dec(PosKey);
          inc(PosKey);
          // Read line which contains the key
          GetLine(PosKey, ptemp);
          // Extract the key and its value
          SplitKeyValue(pTemp, SearchKey, Value);
          if SearchKey = '' then     // Ligne invalide (ne contient pas '='
            exit;
          if FIgnoreCommentLines then
            if SearchKey[1] = #59 then
              exit;
            // Indicate a read only property
            if SearchKey[1] = '-' then
            begin
              ROKey := true;
              SearchKey := Copy(SearchKey, 2, Length(SearchKey) - 1);
            end;
          // Avoid partial key
          Result := CompareText(Trim(Ident), SearchKey);
        end;  // key not found
      end;  // Section not found
    end;
  end;
end;

procedure TDBIniMemo.TypeOfItems(const Section, Ident: string; var TypeItem: TDBIniMemoType);
const
  pTopSection: PChar = '[';
var
  PosSection, PosNextSection: PChar;
  PosKey: PChar;
  pSearchSection: array[0..64] of char;
  pTemp: array[0..127] of char;
  SearchKey, Value: string;
  oMemo: TMemoField;
begin
  FillChar(pSearchSection, sizeof(pSearchSection), #0);
  FillChar(pTemp, sizeof(pTemp), #0);
  oMemo := TMemoField(FDataLink.Field);
  if oMemo <> nil then
  begin
    if (Section <> '') then
    begin
      PosSection := SearchSection(PChar(Section), oMemo);
      // Section found and valid
      if PosSection <> nil then
      begin
        TypeItem := imtValidSection;
        if Ident <> '' then
        begin
          // Search next section
          PosNextSection := StrPos(PosSection + 1, pTopSection);
          // Search the key
          if FCaseSensitive then
            PosKey := StrPos(PosSection, PChar(Ident))
          else
            PosKey := StrIPos(PosSection, PChar(Ident));
          if (PosKey <> nil) and ((PosKey < PosNextSection) or (PosNextSection = nil)) then
          begin
            while (PosKey^ <> #10) and (PosKey >= PosSection) do
              dec(PosKey);
            inc(PosKey);
            // Read line which contains the key
            GetLine(PosKey, ptemp);
            // Extract the key and its value
            SplitKeyValue(pTemp, SearchKey, Value);
            if SearchKey = '' then     // Invalid line (not contain '='
            begin
              TypeItem := imtInvalidKey;
              exit;
            end;
            if SearchKey[1] = #59 then
            begin
              TypeItem := imtCommentLine;
              exit;
            end;
            // Indicate a read only property
            if SearchKey[1] = '-' then
            begin
              TypeItem := imtROKey;
              SearchKey := Copy(SearchKey, 2, Length(SearchKey) - 1);
            end else
              TypeItem := imtRWKey;
            // Avoid partial key
            if (CompareText(Trim(Ident), SearchKey) <> 0) then
              TypeItem := imtInvalidKey;
          end else  // Key not found
            TypeItem := imtInvalidKey;
        end;
      end else  // Section not found
        TypeItem := imtInvalidSection;
    end else
      TypeItem := imtInvalidSection;
  end else
    TypeItem := imtDBError;
end;

function TDBIniMemo.GetObjectSection(obj: TObject): string;
var
  idx: integer;
begin
  idx:= FRegObjects.indexOfObject(obj);
  if ( idx > -1 ) then
    begin
      Result:= FRegObjects.strings[idx];
      if Result = '' then
        Result:= FObjectSection;
    end
  else
    Result:= FObjectSection;
end;

procedure TDBIniMemo.RegisterObject(obj: TObject; ObjectSection: string);
begin
  if (FRegObjects.indexOfObject(obj) = -1) then
    FRegObjects.addObject(ObjectSection, obj);
end;

procedure TDBIniMemo.UnRegisterObject(obj: TObject);
var
  idx: integer;
begin
  idx:= FRegObjects.IndexOfObject(obj);
  if (idx > -1) then
    FRegObjects.Delete(idx);
end;

procedure TDBIniMemo.RestoreObject(obj: TObject; ObjectSection: string);
var
  StrBuf, dtsName, objName: string;
  pObject: Longint;
  savActiv: boolean;
  i, j: integer;
begin
  if ( ObjectSection = '' ) then
    ObjectSection:= FObjectSection;
  if (obj.classInfo <> nil ) then
  begin
    objName := TComponent(obj).Name;
    if (obj is TCheckBox) then
      with (obj as TCheckBox) do
        Checked:= ReadBool(ObjectSection, objName, Checked)
    else if (obj is TEdit) then
      with (obj as TEdit) do
        Text:= ReadString(ObjectSection, objName, Text)
    else if (obj is TMenuItem) then
      with (obj as TMenuItem) do
        Checked:= ReadBool(ObjectSection, objName, Checked)
    else if (obj is TTabbedNoteBook) then
      with (obj as TTabbedNoteBook) do
        PageIndex:= ReadInteger(ObjectSection, objName, PageIndex)
    else if (obj is TDriveComboBox) then
      with (obj as TDriveComboBox) do
      begin
       strBuf := ReadString(ObjectSection, objName, Drive);
       Drive := strBuf[1];
      end
    else if (obj is TDirectoryListBox) then
      with (obj as TDirectoryListBox) do
        Directory:= ReadString(ObjectSection, objName, Directory)
    else if (obj is TTable) then
      with (obj as TTable) do
      begin
        savActiv := ReadBool(ObjectSection, objName + '.Active', Active);
        Active := false;
        try
          AutoCalcFields := ReadBool(ObjectSection, objName + '.AutoCalcFields', AutoCalcFields);
          CachedUpdates := ReadBool(ObjectSection, objName + '.CachedUpdates', CachedUpdates);
          DatabaseName := ReadString(ObjectSection, objName + '.DatabaseName', DatabaseName);
          Exclusive := ReadBool(ObjectSection, objName + '.Exclusive', Exclusive);
          Filter := ReadString(ObjectSection, objName + '.Filter', Filter);
          Filtered := ReadBool(ObjectSection, objName + '.Filtered', Filtered);
          IndexFieldNames := ReadString(ObjectSection, objName + '.IndexFieldNames', IndexFieldNames);
          IndexName := ReadString(ObjectSection, objName + '.IndexName', IndexName);
          MasterFields := ReadString(ObjectSection, objName + '.MasterFields', MasterFields);
          dtsName := ReadString(ObjectSection, objName + '.MasterSource', '');
          if dtsName <> '' then
          begin
            pObject := Longint((Owner as TForm).FindComponent(dtsName));
            if pObject > 0 then
              MasterSource := TDataSource(pObject);
          end else
            MasterSource := nil;
          ReadOnly := ReadBool(ObjectSection, objName + '.ReadOnly', ReadOnly);
          SessionName := ReadString(ObjectSection, objName + '.SessionName', SessionName);
          TableName := ReadString(ObjectSection, objName + '.TableName', TableName);
          Active := savActiv;
        except
          raise;
        end;
      end
    else if (obj is TDataSource) then
      with (obj as TDataSource) do
      begin
        try
          AutoEdit := ReadBool(ObjectSection, objName + '.AutoEdit', AutoEdit);
          dtsName := ReadString(ObjectSection, objName + '.DataSet', '');
          if dtsName <> '' then
          begin
            pObject := Longint((Owner as TForm).FindComponent(dtsName));
            if pObject > 0 then
              DataSet := TDataSet(pObject);
          end else
            DataSet := nil;
          Enabled := ReadBool(ObjectSection, objName + '.Enabled', Enabled);
        except
          raise;
        end;
      end
    else if (obj is TQuery) then
      with (obj as TQuery) do
      begin
        savActiv := ReadBool(ObjectSection, objName + '.Active', Active);
        Active := false;
        try
          AutoCalcFields := ReadBool(ObjectSection, objName + '.AutoCalcFields', AutoCalcFields);
          CachedUpdates := ReadBool(ObjectSection, objName + '.CachedUpdates', CachedUpdates);
          DatabaseName := ReadString(ObjectSection, objName + '.DatabaseName', DatabaseName);
          dtsName := ReadString(ObjectSection, objName + '.DataSource', '');
          if dtsName <> '' then
          begin
            pObject := Longint((Owner as TForm).FindComponent(dtsName));
            if pObject > 0 then
              DataSource := TDataSource(pObject);
          end else
            DataSource := nil;
          Filter := ReadString(ObjectSection, objName + '.Filter', Filter);
          Filtered := ReadBool(ObjectSection, objName + '.Filtered', Filtered);
          ParamCheck := ReadBool(ObjectSection, objName + '.ParamCheck', ParamCheck);
          RequestLive := ReadBool(ObjectSection, objName + '.RequestLive', RequestLive);
          SessionName := ReadString(ObjectSection, objName + '.SessionName', SessionName);
          j := ReadInteger(ObjectSection, objName + '.SQL', 0);
          if j > 0 then
          begin
            SQL.Clear;
            for i := 0 to j - 1 do
              SQL.Add(ReadString(ObjectSection,
                                 objName + '.SQL' + '.'+IntToStr(i),
                                 ''));
          end;
          UniDirectional := ReadBool(ObjectSection, objName + '.UniDirectional', UniDirectional);
          Active := savActiv;
        except
          raise;
        end;
      end;
  end else
    raise EDBIniMemoError.create('TDBIniMemo.RestoreObject : Objet non support!');
end;

procedure TDBIniMemo.RestoreObjects;
var
  objNo: integer;
begin
  for objNo:= 0 to FRegObjects.count - 1 do
    RestoreObject(FRegObjects.Objects[objNo], FRegObjects.Strings[objNo]);
end;

procedure TDBIniMemo.StoreObject(obj: TObject; ObjectSection: string);
var
  dtsName, objName: string;
  i: integer;
begin
  dtsName := '';
  if ( ObjectSection = '' ) then
    ObjectSection:= FObjectSection;
  if (obj.classInfo <> nil ) then
  begin
    objName := TComponent(obj).Name;
    if (obj is TCheckBox) then
      with (obj as TCheckBox) do
        WriteBool(ObjectSection, objName, Checked)
    else if (obj is TEdit) then
      with (obj as TEdit) do
        WriteString(ObjectSection, objName, Text)
    else if (obj is TMenuItem) then
      with (obj as TMenuItem) do
        WriteBool(ObjectSection, objName, Checked)
    else if (obj is TTabbedNoteBook) then
      with (obj as TTabbedNoteBook) do
        WriteInteger(ObjectSection, objName, PageIndex)
    else if (obj is TDriveComboBox) then
      with (obj as TDriveComboBox) do
        WriteString(ObjectSection, objName, Drive)
    else if (obj is TDirectoryListBox) then
      with (obj as TDirectoryListBox) do
        WriteString(ObjectSection, objName, Directory)
    else if (obj is TTable) then
      with (obj as TTable) do
      begin
        WriteBool(ObjectSection, objName + '.Active', Active);
        WriteBool(ObjectSection, objName + '.AutoCalcFields', AutoCalcFields);
        WriteBool(ObjectSection, objName + '.CachedUpdates', CachedUpdates);
        WriteString(ObjectSection, objName + '.DatabaseName', DatabaseName);
        WriteBool(ObjectSection, objName + '.Exclusive', Exclusive);
        WriteString(ObjectSection, objName + '.Filter', Filter);
        WriteBool(ObjectSection, objName + '.Filtered', Filtered);
        WriteString(ObjectSection, objName + '.IndexFieldNames', IndexFieldNames);
        WriteString(ObjectSection, objName + '.IndexName', IndexName);
        WriteString(ObjectSection, objName + '.MasterFields', MasterFields);
        if MasterSource <> nil then
          dtsName := TDataSource(MasterSource).Name;
        WriteString(ObjectSection, objName + '.MasterSource', dtsName);
        WriteBool(ObjectSection, objName + '.ReadOnly', ReadOnly);
        WriteString(ObjectSection, objName + '.SessionName', SessionName);
        WriteString(ObjectSection, objName + '.TableName', TableName);
      end
    else if (obj is TDataSource) then
      with (obj as TDataSource) do
      begin
        WriteBool(ObjectSection, objName + '.AutoEdit', AutoEdit);
        if DataSet <> nil then
          dtsName := TDataSet(DataSet).Name;
        WriteString(ObjectSection, objName + '.DataSet', dtsName);
        WriteBool(ObjectSection, objName + '.Enabled', Enabled);
      end
    else if (obj is TQuery) then
      with (obj as TQuery) do
      begin
        WriteBool(ObjectSection, objName + '.Active', Active);
        WriteBool(ObjectSection, objName + '.AutoCalcFields', AutoCalcFields);
        WriteBool(ObjectSection, objName + '.CachedUpdates', CachedUpdates);
        WriteString(ObjectSection, objName + '.DatabaseName', DatabaseName);
        if DataSource <> nil then
          dtsName := TDataSource(DataSource).Name;
        WriteString(ObjectSection, objName + '.DataSource', dtsName);
        WriteString(ObjectSection, objName + '.Filter', Filter);
        WriteBool(ObjectSection, objName + '.Filtered', Filtered);
        WriteBool(ObjectSection, objName + '.ParamCheck', ParamCheck);
        WriteBool(ObjectSection, objName + '.RequestLive', RequestLive);
        WriteString(ObjectSection, objName + '.SessionName', SessionName);
        WriteInteger(ObjectSection, objName + '.SQL', SQL.Count);
        if SQL.Count > 0 then
          for i := 0 to SQL.Count - 1 do
            WriteString(ObjectSection,
                        objName + '.SQL' + '.'+IntToStr(i),
                        SQL.Strings[i]);
        WriteBool(ObjectSection, objName + '.UniDirectional', UniDirectional);
      end;
    end else
      raise EDBIniMemoError.create('TDBIniMemo.RestoreObject : Objet non support!');
end;

procedure TDBIniMemo.StoreObjects;
var
  objNo: integer;
begin
  for objNo:= 0 to FRegObjects.count - 1 do
    StoreObject(FRegObjects.Objects[objNo], FRegObjects.Strings[objNo]);
end;

end.
